package PlayBot::utils::db;

use strict;
use warnings;
use utf8;

use DBI;
use JSON;
use FindBin;

my $conf;
my $dbh;

BEGIN {
    chdir "$FindBin::Bin/";
    local $/;
    open CONF, '<', 'playbot.conf';
    my $json = <CONF>;
    $conf = decode_json($json);
}

sub main_session {
    $dbh = get_new_session() if (not $dbh or not $dbh->ping);
    return $dbh;
}

sub get_new_session {
    my $dbh = DBI->connect('DBI:mysql:'.$conf->{'bdd'}.';host='.$conf->{'host'}.';mysql_enable_utf8mb4=1', $conf->{'user'}, $conf->{'passwd'}, {
            RaiseError => 1,
	        AutoCommit => 0
    	})
    	or die("Couldn't connect to database: ".DBI->errstr);

    #$dbh->{'mysql_enable_utf8mb4'} = 1;    
    #$dbh->do(qq{SET NAMES utf8;});
    return $dbh;
}

sub set_filename {
    my ($id, $file) = @_;
    my $dbh = main_session();

	my $sth = $dbh->prepare('UPDATE playbot SET file = ? WHERE id = ?');
	die ("Couldn't prepare querie; aborting") unless (defined $sth);
	$sth->execute($file, $id);
    $dbh->commit;
}

1;
